import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

public class HelloServer extends UnicastRemoteObject implements Hello
{
	public HelloServer() throws RemoteException
	{
		super();
	}

	public String sayHello(MyParam p)
	{
		String res = "";
		System.out.println("Hello-Server called");
		try {
			res = "Hello World, Param method returns " + p.someMethod();
		}
		catch (Exception e) {
			System.out.println("Error: " + e.getMessage());
			e.printStackTrace();
		}
		return res;
	}
	
	public static void main(String args[])
	{
		try {
			// Server-Objekt erzeugen
			HelloServer obj = new HelloServer();

			// Referenz beim Namensdienst registrieren
			Naming.rebind("rmi://localhost/Hello-Server", obj);

			System.out.println("Hello-Server registered");
		}
		catch (Exception e) {
			System.out.println("Error: " + e.getMessage());
			e.printStackTrace();
		}
	}
}
